Content.makeFrontInterface(1080, 600);

//AudioWave LAF
const var SampleStart = Sampler1.SampleStart;
const var SampleEnd = Sampler1.SampleEnd;
const var laf = Engine.createGlobalScriptLookAndFeel();
laf.registerFunction("drawThumbnailRange", function(g, obj) {
    g.fillAll(0);
    
    // Start point (using existing position property)
    var startX = obj.position * obj.area[2];
    g.setColour(0xFFFF5400);
    g.drawLine(startX, startX, 0, obj.area[3], 10.0);
    g.setColour(0xFFFFFFFF);
    g.drawLine(startX, startX, 0, obj.area[3], 1.5);
    g.setColour(0xffFFFFFF);
    g.setFont("regular", 12.0);
    g.drawAlignedText("Start Pt", [startX + 5, 5, 50, 20], "left");
    
    // End point (using new endPosition property)
    var endX = obj.endPosition * obj.area[2];
    g.setColour(0xFFFF5400);
    g.drawLine(endX, endX, 0, obj.area[3], 10.0);
    g.setColour(0xFFFFFFFF);
    g.drawLine(endX, endX, 0, obj.area[3], 1.5);
    g.setColour(0xffFFFFFF);
    g.setFont("regular", 12.0);
    g.drawAlignedText("End Pt", [endX - 55, 5, 50, 20], "right");
});



// Variables to store loop points
const var loopPoints = {
    start: 0.0,
    end: 1.0,
    enabled: false,
    settingStart: true, // Flag to toggle between setting start and end points
    endPoint: 1.0 // Adding the EndPoint property to the object
};




laf.registerFunction("drawThumbnailRange", function(g, obj) {
    g.fillAll(0);
    
    // Draw playhead position
    var x = obj.position * obj.area[2];
    
    g.setColour(0xFFFF5400);
    g.drawLine(x, x, 0, obj.area[3], 10.0);
    
    g.setColour(0xFFFFFFFF);
    g.drawLine(x, x, 0, obj.area[3], 1.5);
    
    // Draw start point marker
        var startPointX = loopPoints.start * obj.area[2];
        g.setColour(0xFFFF5400);
        g.drawLine(startPointX, startPointX, 0, obj.area[3], 10.0);
        g.setColour(0xFFFFFFFF);
        g.drawLine(startPointX, startPointX, 0, obj.area[3], 1.5);
        g.setFont("regular", 12);
        g.setColour(Colours.white);
        g.drawAlignedText("Start", [startPointX - 0, 5, 40, 20], "centred");  // Tekst voor startpunt
    
    // Draw end point marker
    var endPointX = loopPoints.endPoint * obj.area[2];
    g.setColour(0xFFFF5400);
    g.drawLine(endPointX, endPointX, 0, obj.area[3], 10.0);
    g.setColour(0xFFFFFFFF);
    g.drawLine(endPointX, endPointX, 0, obj.area[3], 1.5);
    g.setFont("regular", 12);
    g.setColour(Colours.white);
    g.drawAlignedText("End", [endPointX - 40, 5, 40, 20], "centred");


    // Draw loop start and end markers if loop is enabled
    if (loopPoints.enabled) {
        var loopStartX = loopPoints.start * obj.area[2];
        var loopEndX = loopPoints.end * obj.area[2];
        
        // Draw loop region background
        g.setColour(Colours.withAlpha(0xFFFF5400, 0.15));
        g.fillRect([loopStartX, 0, loopEndX - loopStartX, obj.area[3]]);
        
        // Draw loop start marker
        g.setColour(0xFF8d478d);
        g.drawLine(loopStartX, loopStartX, 0, obj.area[3], 2.0);
        
        // Draw loop end marker
        g.setColour(0xFF8d478d);
        g.drawLine(loopEndX, loopEndX, 0, obj.area[3], 2.0);
        
        // Draw loop region border
        g.setColour(Colours.withAlpha(0xFFFF5400, 0.5));
        g.drawRect([loopStartX, 0, loopEndX - loopStartX, obj.area[3]], 1);
        

    }
});

laf.registerFunction("drawThumbnailPath", function(g, obj) {
    g.fillAll(obj.bgColour);
    
    var a = obj.area;
    g.setGradientFill([0xFFFF5400, a[0], a[1], 0xFF8d478d, a[2], a[3]]);
    g.drawPath(obj.path, obj.area,1.5);
    g.fillPath(obj.path, obj.area);
});



function onNoteOn()
{
	
}
 function onNoteOff()
{
	
}
 function onController()
{
	
}
 function onTimer()
{
	
}
 function onControl(number, value)
{
	
}
 